//IBHLSPAC JOB (SYS),'INSTALL IBHLSPAC',CLASS=S,MSGCLASS=X              
//*                                                                     
//* SOURCE: CBT (V430) FILE #21                                         
//* TARGET: SYSC.LINKLIB                                                
//*                                                                     
//********************************************************************* 
//* THIS JOB INSTALLS IBHLSPAC INTO SYSC.LINKLIB.                     * 
//********************************************************************* 
//*                                                                     
//IBHLSPAC EXEC ASMFCL,PARM='LIST,NODECK,LOAD,NOTERM',                  
//             MAC1='SYS1.AMODGEN',REGION.ASM=2M                        
//ASM.SYSIN DD *                                                        
         TITLE 'I B H L S P A C    DIRECT ACCESS VOLUME SPACE INFORMATIX
               ON'                                                      
IBHLSPAC CSECT                                                          
*                                                                       
*********************************************************************** 
*                                                                     * 
*    IIII   BBBBBB  HH   HH LL       SSSSS  PPPPPP     A     CCCCC    * 
*     II    BB   BB HH   HH LL      SS   SS PP   PP   AAA   CC   CC   * 
*     II    BB   BB HH   HH LL      SS      PP   PP  AA AA  CC   CC   * 
*     II    BBBBBB  HHHHHHH LL       SSSSS  PP   PP AA   AA CC        * 
*     II    BB   BB HH   HH LL           SS PPPPPP  AA   AA CC        * 
*     II    BB   BB HH   HH LL      SS   SS PP      AAAAAAA CC   CC   * 
*     II    BB   BB HH   HH LL      SS   SS PP      AA   AA CC   CC   * 
*    IIII   BBBBBB  HH   HH LLLLLLL  SSSSS  PP      AA   AA  CCCCC    * 
*                                                                     * 
*---------------------------------------------------------------------* 
*                                                                     * 
*        THIS ROUTINE USES THE SMF LSPACE ROUTINE (SVC 78)            * 
*        TO COMPUTE VOLUME SPACE STATISTICS FOR ALL ONLINE            * 
*        DA DEVICES.                                                  * 
*                                                                     * 
*        DDNAMES:  SYSPRINT - TO SYSOUT                               * 
*                  VATLST - ALLOCATE TO SYS1.PARMLIB(VATLSTXX)        * 
*                YOUR VATLST SHOULD HAVE COMMENTS STARTING COL        * 
*                30 WHICH ARE THEN DISPLAYED IN THE REPORT.           * 
*                  SYSIN (OPTIONAL) - SPECIFY TABLE OF UP TO 20    JLM* 
*                                     MASKS TO PRODUCE SUMMARY     JLM* 
*                                     REPORT BY VOLUME GROUPS.     JLM* 
*                                                                     * 
*                           WRITTEN BY G M SCHLESAK / BELL & HOWELL   * 
*        UPDATE 2020-04    JAY MOSELEY                             JLM* 
*           ADDED SUPPORT FOR 2311/3375/3390 DASD                  JLM* 
*        UPDATE 2024-05-28 JAY MOSELEY                             JLM* 
*           ORIGINAL INCLUDED HARD CODED SELECTION OF VOLUMES TO   JLM* 
*           SUMMARIZE BY VOLUME SERIAL NUMBER MASK. I ADDED CODE   JLM* 
*           TO READ MASK VALUES FROM SYSIN FOR UP TO 20 MASKS AND  JLM* 
*           ONLY PRODUCE THE REPORT IF SYSIN IS ALLOCATED AND      JLM* 
*           PRESENT DURING EXECUTION.                              JLM* 
*********************************************************************** 
*                                                                       
*-------------------------------------------------------------------*   
*                                                                   *   
*                      D I S C L A I M E R                          *   
*                                                                   *   
*  BELL AND HOWELL COMPANY MAKES NO WARRANTY EXPRESSED OR IMPLIED   *   
*  AS TO THE FITNESS OF THIS CODE UNDER YOUR ENVIRONMENT.  THIS     *   
*  EXIT SHOULD BE COMPREHENSIVELY TESTED BEFORE IT IS PLACED INTO   *   
*  YOUR PRODUCTION ENVIRONMENT.  IF YOU HAVE ANY QUESTIONS CONTACT: *   
*                                                                   *   
*           ROBERT M. SIRKIS                                        *   
*           TECHNICAL SUPPORT SPECIALIST                            *   
*           BELL AND HOWELL COMPANY                                 *   
*           2231 WEST HOWARD STREET                                 *   
*           EVANSTON, IL 60202                                      *   
*           (312) 570-4687                                          *   
*                                                                   *   
*-------------------------------------------------------------------*   
*                                                                       
R0       EQU   0                                                        
R1       EQU   1                                                        
R2       EQU   2                                                        
R3       EQU   3                                                        
R4       EQU   4                                                        
R5       EQU   5                                                        
R6       EQU   6                                                        
R7       EQU   7                                                        
R8       EQU   8                                                        
R9       EQU   9                                                        
R10      EQU   10                                                       
R11      EQU   11                                                       
R12      EQU   12                                                       
R13      EQU   13                                                       
R14      EQU   14                                                       
R15      EQU   15                                                       
         EJECT                                                          
*                                                                       
***  P E R F O R M   L I N K A G E   A N D   O P E N   F I L E S        
*                                                                       
         SAVE (14,12),,*                                                
         LR    R12,R15                                                  
         USING IBHLSPAC,R12                                             
         ST    R13,SAVEAREA+4                                           
         LA    R11,SAVEAREA                                             
         ST    R11,8(R13)                                               
         LR    R13,R11                                                  
*                                                                       
         OPEN  (SYSPRINT,(OUTPUT))                                      
         LTR   R15,R15             DID FILE OPEN?                       
         BNZ   RETURN              NO                                   
*                                                                       
***  LOAD COMMENT TABLE FROM VATLST FILE                                
*                                                                       
         OPEN  (VATLST,(INPUT))                                         
         LTR   R15,R15             DID FILE OPEN?                       
         BNZ   GETCVT              NO                                   
*                                                                       
         SLR   R4,R4               ZERO TABLE ENTRY COUNTER             
         LA    R5,CMNTABLE         POINT AT BEGINNING OF COMMENT TABLE  
         USING CMNTENTY,R5         ADDRESS TABLE ENTRY SYMBOLICALLY     
GETCMNTS GET   VATLST,VATRCRD                                           
         MVC   CMNTVOLS,VATRVOLS   PUT VOLSER INTO TABLE                
         MVC   CMNTCMNT,VATRCMNT   PUT COMMENT FIELD INTO TABLE         
         LA    R4,1(R4)            BUMP TABLE ENTRY COUNTER             
         LA    R5,CMNTENTL(R5)     POINT TO NEXT TABLE ENTRY            
         B     GETCMNTS            GO GET NEXT RECORD                   
         DROP  R5                                                       
*                                                                       
EOFCMNTS CLOSE (VATLST)                                                 
         S     R5,=A(CMNTENTL)     POINT BACK TO THE LAST ENTRY         
         ST    R5,TOTENTP          SAVE LAST ENTRY POINTER              
         ST    R4,TOTENTN          SAVE TOTAL NUMBER OF ENTRIES         
*                                                                   JLM 
* LOOP THROUGH TIOT LOOKING FOR SYSIN DD                            JLM 
*                                                                   JLM 
SCANTIOT L     R2,CVTPTR               ADDRESS OF CVT               JLM 
         L     R2,CVTTCBP-CVTMAP(,R2)  TCB TABLE                    JLM 
         L     R2,4(,R2)               TCBOLD (CURRENT)             JLM 
         L     R2,TCBTIO-TCB(,R2)      TIOT                         JLM 
         LA    R2,TIOENTRY-TIOT1(,R2)  LOAD PAST TIOT HEADER        JLM 
         USING TIOENTRY,R2             ESTABLISH ADDRESSABILITY     JLM 
         SR    R3,R3                                                JLM 
LOOPTIOT IC    R3,TIOELNGH             GET ENTRY LENGTH             JLM 
         LTR   R3,R3                   LAST ENTRY PASSED?           JLM 
         BZ    DONETIOT                                             JLM 
         CLC   TIOEDDNM,=CL8'SYSIN'    IS THIS SYSIN DD?            JLM 
         BNE   NEXTTIOT                                             JLM 
         MVI   SYSINFND,C'Y'           SET FLAG FOR SYSIN SUPPLIED  JLM 
         B     DONETIOT                FINISHED, EXIT               JLM 
NEXTTIOT AR    R2,R3                   BUMP TO NEXT TIOT ENTRY      JLM 
         B     LOOPTIOT                LOOP                         JLM 
DONETIOT EQU   *                       FINISHED WITH TIOT           JLM 
         DROP  R2                                                   JLM 
*                                                                   JLM 
* READ MASKS FROM SYSIN AND LOAD INTO MEMORY (LIMIT OF 20)          JLM 
*                                                                   JLM 
         CLI   SYSINFND,C'Y'           WAS SYSIN ALLOCATED?         JLM 
         BNE   GETCVT                  NO, CONTINUE                 JLM 
*                                                                   JLM 
         OPEN  (SYSIN,(INPUT))                                      JLM 
         LTR   R15,R15             DID FILE OPEN?                   JLM 
         BNZ   GETCVT              NO, CONTINUE                     JLM 
*                                                                   JLM 
GETSYSIN GET   SYSIN,SYSINREC      READ SYSIN                       JLM 
         CLI   MEMALLOC,C'Y'       HAS MEMORY BEEN ALLOCATED?       JLM 
         BE    STOREMSK            YES, GO STORE                    JLM 
*                                                                   JLM 
         GETMAIN R,LV=CLSMEML      ALLOCATE MEMORY                  JLM 
         LR    R10,R1              R10->ACQUIRED MEMORY             JLM 
         USING CLSMEM,R10                                           JLM 
         MVI   MEMALLOC,C'Y'       INDICATE MEMORY ALLOCATED        JLM 
         ST    R10,MEMADDR         SAVE ADDR OF ACQUIRED MEMORY     JLM 
*                                                                   JLM 
         XR    R2,R2               R2-> COUNT OF ENTRIES STORED     JLM 
STOREMSK CH    R2,=H'20'           HAVE WE REACHED MAXIMUM?         JLM 
         BL    STOREGO             NO, CONTINUE                     JLM 
         WTO   'MAXIMUM MASKS LOADED FROM SYSIN - IGNORING REST'    JLM 
         B     EOFSYSIN            TERMINATE READING SYSIN          JLM 
*                                                                   JLM 
STOREGO  MVC   CLSMSK,SYSINVOL     STORE MASK IN TABLE              JLM 
         MVI   SYSINVOL+6,C'*'     ENSURE MASK DELIMITER            JLM 
         LA    R4,SYSINVOL         ADDRESS BEGINNING OF MASK        JLM 
MASKLOOP CLI   0(R4),C'*'          END OF SIGNIFICANCE FOR MASK?    JLM 
         BE    MASKEND             YES, GO STORE LENGTH             JLM 
         LA    R4,1(,R4)           INCREMENT TO NEXT POSITION       JLM 
         B     MASKLOOP            LOOP TO TEST NEXT CHARACTER      JLM 
*                                                                   JLM 
MASKEND  S     R4,=A(SYSINVOL)     COMPUTE LENGTH OF MASK           JLM 
         STH   R4,CLSMSKL          STORE MASK LENGTH IN TABLE       JLM 
         MVC   CLSCYL,=PL4'0'      INITIALIZE CYLINDER COUNT        JLM 
         MVC   CLSTRK,=PL4'0'        AND TRACK COUNT IN TABLE       JLM 
         LA    R2,1(,R2)           INCREMENT STORED COUNT           JLM 
         STH   R2,CLSHI            STORE UPDATED HIGH TABLE COUNT   JLM 
         LA    R10,CLSENTL(R10)    BUMP ADDR TO NEXT OPEN ENTRY     JLM 
         B     GETSYSIN            LOOP TO READ NEXT RECORD         JLM 
*                                                                   JLM 
EOFSYSIN CLOSE (SYSIN)                                              JLM 
         LH    R2,CLSHI            GET NUMBER OF ENTRIES STORED     JLM 
         LTR   R2,R2               ANY MASKS STORED?                JLM 
         BZ    GETCVT              NO, CONTINUE                     JLM 
         MVC   CLSMSK,=CL6'OTHER ' ESTABLISH 'OTHER' CATEGORY       JLM 
         MVC   CLSMSKL,=H'0'       MASK LENGTH UNUSED, SET TO ZERO  JLM 
         MVC   CLSCYL,=PL4'0'      INITIALIZE CYLINDER COUNT        JLM 
         MVC   CLSTRK,=PL4'0'        AND TRACK COUNT IN TABLE       JLM 
         LA    R2,1(,R2)           INCREMENT STORED COUNT           JLM 
         STH   R2,CLSHI            STORE UPDATED HIGH TABLE COUNT   JLM 
*                                                                       
***  F I L L   I N   &   P R I N T   P A G E   H E A D I N G            
*                                                                       
GETCVT   L     R2,CVTPTR           GET ADDR OF CVT                      
         USING CVT,R2                                               JLM 
         L     R3,CVTSMCA          GET ADDR OF SMCA                 JLM 
         LTR   R3,R3               IS SMF IN SYSTEM?                    
         BZ    *+10                NO, DO NOT MOVE SYSID                
         MVC   HEADING1,SMCASID(R3) MOVE SYSID TO HEADING               
         DROP  R2                                                   JLM 
         CALL  Y2KGETD,(Y2KGD)         RETRIEVE SYSTEM DATE/TIME    JLM 
         MVC   Y2KDFG,Y2KGDG           MOVE DATE TO FORMAT          JLM 
         CALL  Y2KDFMT,(Y2KDF)         RETRIEVE SYSTEM DATE/TIME    JLM 
         MVC   HEADING2,Y2KDFD         MOVE DATE TO HEADING         JLM 
         MVC   HEADING3(2),Y2KGDH      MOVE HOUR TO HEADING         JLM 
         MVC   HEADING3+3(2),Y2KGDM    MOVE MINUTE TO HEADING       JLM 
         MVC   HEADING3+6(2),Y2KGDS    MOVE SECOND TO HEADING       JLM 
*                                                                       
* PRINT PAGE HEADINGS                                                   
*                                                                       
         PUT   SYSPRINT,HEADINGA                                        
         PUT   SYSPRINT,HEADINGB                                        
         PUT   SYSPRINT,HEADINGC                                        
         PUT   SYSPRINT,OUTLINE                                         
*                                                                       
***  S E A R C H   U C B S   F O R   D A   D E V I C E S                
*                                                                       
         L     R2,CVTPTR           GET ADDR OF CVT                      
         L     R2,CVTILK2-CVT(R2)  GET ADDR OF UCB ADDR LIST        JLM 
CHECKUCB SR    R3,R3                                                    
         CH    R3,0(R2)            IS THIS A ZERO ENTRY                 
         BE    NEXTUCB             YES, GOTO NEXT ENTRY                 
         LH    R3,0(R2)            GET UCB ADDR                         
         CH    R3,XFFFF            END OF LIST?                         
         BE    SPACETOT            YES, GO PRINT TOTAL LINE             
         BAL   R11,VOLINFO         PROCESS THIS UCB                     
*                                                                       
NEXTUCB  LA    R2,2(R2)            GET NEXT UCB ADDR                    
         B     CHECKUCB                                                 
*                                                                       
***  G E T   V O L U M E   I N F O R M A T I O N                        
*                                                                       
VOLINFO  EQU   *                                                        
         USING UCBDSECT,R3                                              
         CLI   UCBTYP+2,TYPDA      IS IT DA?                            
         BNER  R11                 NO, GOTO NEXT UCB                    
         CLI   UCBTYP+3,TYP2321    IS IT 2321 DATA CELL?                
         BER   R11                 YES, GOTO NEXT UCB                   
         TM    UCBSTAT,UCBONLI     IS DEVICE ONLINE                     
         BNOR  R11                 NO, GOTO NEXT UCB                    
         LR    R0,R3               SET R0 TO UCB IN QUESTION.           
         L     R15,=V(OPTCHK)      GET OPTCHK ADDRESS.                  
         BALR  R14,R15             CALL OPTCHK ROUTINE.                 
         LTR   R15,R15             HAS UCB BEEN PROCESSED VIA OPTCHAN?  
         BNER  R11                 YES-GOTO NEXT UCB.                   
         MVC   OUTLINE+1(L'OUTLINE-1),OUTLINE  CLEAR PRINT LINE         
         MVC   OUTLINE1,UCBVOLI    MOVE VOLSER                          
         MVC   OUTLINE4,UCBNAME    MOVE UNIT ADDRESS                    
*                                                                       
***  PUT COMMENT FROM VATLST INTO PRINT LINE                            
*                                                                       
         ICM   R4,15,TOTENTN       GET TOTAL NUMBER OF ENTRIES          
         BZ    DOLSPACE            NO TABLE ENTRIES                     
         L     R5,TOTENTP          POINT TO LAST TABLE ENTRY            
         USING CMNTENTY,R5         ADDRESS TABLE ENTRY SYMBOLICALLY     
FNDCLUP1 CLC   UCBVOLI,CMNTVOLS    IS THIS THE RIGHT VOLSER             
         BE    FNDCLUP2            YES, WE GOT IT                       
         S     R5,=A(CMNTENTL)     BUMP DOWN TO NEXT ENTRY              
         BCT   R4,FNDCLUP1         GO CHECK IT                          
         B     DOLSPACE            NO MATCHING ENTRY                    
FNDCLUP2 MVC   OUTLINE8,CMNTCMNT   PUT COMMENT INTO OUTPUT              
         DROP  R5                                                       
*                                                                       
***  G O   T O   L S P A C E   R O U T I N E                            
*                                                                       
DOLSPACE LR    R0,R3               SET UP UCB ADDRESS                   
         LA    R1,PARMAREA         30 BYTE MESSAGE AREA                 
         SVC   78                  ISSUE LSPACE SVC                     
         LTR   R15,R15             TEST RETURN CODE                     
         BNZ   SETERR                                                   
*                                                                       
* PACK VALUES RETURNED BY LSPACE                                        
*                                                                       
         PACK  PRMFSCTP,PRMFSCTC   PACK MAX CONTIG TRKS                 
         PACK  PRMFSCCP,PRMFSCCC   PACK MAX CONTIG CYLS                 
         PACK  PRMFSEXP,PRMFSEXC   PACK NUMBER OF EXTENTS               
         PACK  PRMFSTTP,PRMFSTTC   PACK TOTAL FREE TRKS                 
         PACK  PRMFSTCP,PRMFSTCC   PACK TOTAL FREE CYLS                 
*                                                                       
* PUT VALUES IN PRINT LINE                                              
*                                                                       
         MVC   OUTLINE2,PATTERN1                                        
         ED    OUTLINE2,FREESPAC                                        
         CP    PRMFSEXP,=P'50'     MORE THAN 50 EXTENTS                 
         BNH   *+8                                                      
         MVI   OUTLINE2+20,C'*'    HI-LIGHT                             
         CP    PRMFSTTP,=P'200'    MORE THAN 200 FREE TRACKS            
         BNH   *+8                                                      
         MVI   OUTLINE2+13,C'*'    HI-LIGHT                             
         B     COMPDEV             GO COMPUTE DEVICE TYPE               
*                                                                       
* MOVE ERROR MSG TO OUTPUT LINE                                         
*                                                                       
SETERR   EQU   *                                                        
         SLA   R15,2                                                    
         AL    R15,=A(MSGTBL-16)   ADDRESS MSG TABLE                    
         MVC   OUTLINE3,0(R15)     MOVE MSG INTO LINE                   
         OI    ERRINDIC,LSPACERR   INDICATE ERROR RETURNED              
*                                                                       
***  C O M P U T E   D E V   T Y P E   A N D   U P D A T E              
***  D E V   T Y P E   S P A C E   T O T A L S                          
*                                                                       
COMPDEV  LA    R4,DEVTBL           GET ADDR OF DEVICE TABLE             
         USING TBLDSECT,R4                                              
CHKDEV   CLI   TBLDEV,ENDTBL       IS THIS THE LAST ENTRY?              
         BE    MVDVTYP             YES, WE MUST USE THIS ENTRY          
         CLC   UCBTYP+3(1),TBLDEV  UCB MATCH TABLE ENTRY?               
         BNE   NXTNTRY             NO, GO TO NEXT DEVICE ENTRY          
MVDVTYP  MVC   OUTLINE5,TBLNAME    MOVE DEV NAME TO OUTPUT LINE         
         MVI   TBLUSE,TBLUSED      INDICATE DEVICE HAS BEEN FOUND       
*                                                                   JLM 
* ACCUMULATE SPACE IN CATEGORY TABLE BASED ON VOLSER MASK           JLM 
*                                                                   JLM 
         TM    ERRINDIC,LSPACERR   LSPACE ERROR?                    JLM 
         BO    VOLCAT              YES, SKIP CATEGORY ACCUMULATION  JLM 
         L     R10,MEMADDR         LOAD ADDR OF ACQUIRED MEMORY     JLM 
         LTR   R10,R10             WAS TABLE LOADED FROM SYSIN?     JLM 
         BZ    VOLCAT              NO, SKIP CATEGORY ACCUMULATION   JLM 
         XR    R8,R8               R8 FOR LOOP CONTROL              JLM 
         LH    R8,CLSHI            GET NUMBER OF ENTRIES            JLM 
         BCTR  R8,0                DECREMENT (LAST ENTRY IS 'OTHER')JLM 
CATTEST  LH    R1,CLSMSKL          GET MASK SIGNIFICANT LENGTH      JLM 
         BCTR  R1,0                DECREMENT FOR EX                 JLM 
         EX    R1,CMPMASK          EXECUTE COMPARE                  JLM 
         BNE   CATLOOP             NO, LOOP                         JLM 
         AP    CLSCYL,PRMFSTCP     ADD FREE CYKS TOTAL              JLM 
         AP    CLSTRK,PRMFSTTP     ADD FREE TRKS TOTAL              JLM 
         B     VOLCAT              GO GET VOLUME CATEGORY           JLM 
CMPMASK  CLC   CLSMSK(*-*),UCBVOLI TABLE ENT MATCH THIS VOL? (EXE'D)JLM 
CATLOOP  LA    R10,CLSENTL(R10)    BUMP MEMORY ADDR TO NEXT ENTRY   JLM 
         BCT   R8,CATTEST          LOOP TO TEST NEXT ENTRY          JLM 
         AP    CLSCYL,PRMFSTCP     ADD FREE CYKS TOTAL TO 'OTHER'   JLM 
         AP    CLSTRK,PRMFSTTP     ADD FREE TRKS TOTAL TO 'OTHER'   JLM 
*                                                                       
* CHECK FOR VOL TYPE                                                    
*                                                                       
VOLCAT   TM    UCBSTAB,UCBBPRV     IS IT A PRV VOLUME?                  
         BNO   CHKPUB              NO                                   
         MVC   OUTLINE6,VOLTPRV    MOVE VOL TYPE TO OUTPUT LINE         
         TM    ERRINDIC,LSPACERR   DO WEE HAVE NUMBERS?                 
         BO    VOLSTAT             NO                                   
         AP    TBLCPRV,PRMFSTCP    ADD FREE CYLS                        
         AP    TBLTPRV,PRMFSTTP    ADD FREE TRKS                        
         AP    TOTCPRV,PRMFSTCP    ADD FREE CYLS TOTAL                  
         AP    TOTTPRV,PRMFSTTP    ADD FREE TRKS TOTAL                  
         B     VOLSTAT             GO GET VOLUME STATUS                 
*                                                                       
CHKPUB   TM    UCBSTAB,UCBBPUB     IS IT A PUB VOLUME?                  
         BNO   CHKSTR              NO                                   
         TM    ERRINDIC,LSPACERR   DO WEE HAVE NUMBERS?                 
         BO    VOLSTAT             NO                                   
         MVC   OUTLINE6,VOLTPUB    MOVE VOL TYPE TO OUTPUT LINE         
         AP    TBLCPUB,PRMFSTCP    ADD FREE CYLS                        
         AP    TBLTPUB,PRMFSTTP    ADD FREE TRKS                        
         AP    TOTCPUB,PRMFSTCP    ADD FREE CYLS TOTAL                  
         AP    TOTTPUB,PRMFSTTP    ADD FREE TRKS TOTAL                  
         B     VOLSTAT             GO GET VOLUME STATUS                 
*                                                                       
CHKSTR   TM    UCBSTAB,UCBBSTR     IS IT A STR VOLUME?                  
         BNO   VOLSTAT             GO GET VOLUME STATUS                 
         TM    ERRINDIC,LSPACERR   DO WEE HAVE NUMBERS?                 
         BO    VOLSTAT             NO                                   
         MVC   OUTLINE6,VOLTSTR    MOVE VOL TYPE TO OUTPUT LINE         
         AP    TBLCSTR,PRMFSTCP    ADD FREE CYLS                        
         AP    TBLTSTR,PRMFSTTP    ADD FREE TRKS                        
         AP    TOTCSTR,PRMFSTCP    ADD FREE CYLS TOTAL                  
         AP    TOTTSTR,PRMFSTTP    ADD FREE TRKS TOTAL                  
         B     VOLSTAT             GO GET VOLUME STATUS                 
*                                                                       
NXTNTRY  CLI   TBLDEV,ENDTBL       IS THIS END OF TABLE                 
         BE    VOLSTAT             YES, GO COMPUTE VOL STATUS           
         LA    R4,NXTDEV           POINT TO NEXT DEVICE ENTRY           
         B     CHKDEV              GO SEE IF MATCH                      
*                                                                       
***  C O M P U T E   V O L U M E   S T A T U S                          
*                                                                       
VOLSTAT  MVC   OUTLINE7,STATRMOV   DEFAULT STATUS IS REMOVABLE          
         TM    UCBSTAT,UCBRESV     IS IT RESERVED?                      
         BNO   *+10                                                     
         MVC   OUTLINE7,STATRESV   MOVE VOL STAT TO OUTPUT LINE         
         TM    UCBSTAT,UCBPRES     IS IT PERM RESIDENT?                 
         BNO   *+10                                                     
         MVC   OUTLINE7,STATPRES   MOVE VOL STAT TO OUTPUT LINE         
         DROP  R3                                                       
*                                                                       
***  P R I N T   O U T P U T    L I N E                                 
*                                                                       
PUTLINE  PUT   SYSPRINT,OUTLINE                                         
         NI    ERRINDIC,X'FF'-LSPACERR                                  
         BR    R11                 GO TO NEXT UCB                       
*                                                                       
***  P R I N T   S P A C E   T O T A L S   B Y                          
***  D E V   T Y P E   &   V O L   T Y P E                              
*                                                                       
SPACETOT EQU   *                                                        
*                                                                       
* PRINT TOTALS FROM CATEGORY TABLE BASED ON VOLSER MASK                 
*                                                                       
         L     R10,MEMADDR         LOAD ADDR OF ACQUIRED MEMORY     JLM 
         LTR   R10,R10             IS TABLE PRESENT?                JLM 
         BZ    DEVTYPET            NO, GO PRINT DEVTYPE TABLE       JLM 
         XR    R8,R8               R8 FOR LOOP CONTROL              JLM 
         LH    R8,CLSHI            GET NUMBER OF ENTRIES            JLM 
*                                                                       
* PRINT VOL TYPE HEADINGS                                           JLM 
*                                                                       
         PUT   SYSPRINT,HEADINGH                                    JLM 
         PUT   SYSPRINT,HEADINGF                                    JLM 
         PUT   SYSPRINT,HEADINGG                                    JLM 
         MVC   OUTLINE+1(L'OUTLINE-1),OUTLINE CLEAR PRINT LINE      JLM 
         PUT   SYSPRINT,OUTLINE                                     JLM 
*                                                                       
PRCATENT MVC   OUTLINEA,CLSMSK     MOVE CATEGORY TO OUTPUT LINE     JLM 
         MVC   OUTLINEB,PATTERN3   MOVE EDIT PATTERN TO OUTPUT LINE JLM 
         ED    OUTLINEB,CLSCYL     EDIT FREE SPACE VALUES           JLM 
         PUT   SYSPRINT,OUTLINE                                     JLM 
         MVC   OUTLINE+1(L'OUTLINE-1),OUTLINE CLEAR PRINT LINE      JLM 
         LA    R10,CLSENTL(R10)    BUMP MEMORY ADDR TO NEXT ENTRY   JLM 
         BCT   R8,PRCATENT         LOOP TO TEST NEXT ENTRY          JLM 
*                                                                       
DEVTYPET EQU   *                                                    JLM 
* PRINT DEV TYPE HEADINGS                                               
         PUT   SYSPRINT,HEADINGH                                        
         PUT   SYSPRINT,HEADINGD                                        
         PUT   SYSPRINT,HEADINGE                                        
         MVC   OUTLINE+1(L'OUTLINE-1),OUTLINE CLEAR PRINT LINE          
         PUT   SYSPRINT,OUTLINE                                         
*                                                                       
* PRINT THE TOTALS                                                      
*                                                                       
         LA    R4,DEVTBL                                                
         USING TBLDSECT,R4                                              
NEWNTRY  CLI   TBLUSE,TBLUSED      WAS THIS ENTRY USED?                 
         BNE   UPDTPTR             NO, GO TO NEXT DEVICE ENTRY          
         MVC   OUTLINEA,TBLNAME    MOVE DEVICE NAME TO OUTPUT LINE      
         MVC   OUTLINEB,PATTERN2   MOVE EDIT PATTERN TO OUTPUT LINE     
         ED    OUTLINEB,DEVTOTS    EDIT FREE SPACE VALUES               
         PUT   SYSPRINT,OUTLINE                                         
         MVC   OUTLINE+1(L'OUTLINE-1),OUTLINE CLEAR PRINT LINE          
UPDTPTR  CLI   TBLDEV,ENDTBL       IS THIS THE LAST ENTRY?              
         LA    R4,NXTDEV           POINT TO NEXT DEVICE ENTRY           
         BNE   NEWNTRY             THERE ARE MORE ENTRIES               
         MVC   OUTLINE(L'TOTAL),TOTAL                                   
         MVC   OUTLINEB,PATTERN2   MOVE EDIT PATTERN TO OUTPUT LINE     
         ED    OUTLINEB,FREETOTS   EDIT FREE SPACE TOTALS               
         PUT   SYSPRINT,OUTLINE                                         
*                                                                       
         CLOSE (SYSPRINT)                                               
*                                                                       
***  R E T U R N   T O    S Y S T E M                                   
*                                                                       
RETURN   EQU   *                                                        
*                                                                       
         CLI   MEMALLOC,C'Y'           WAS MEMORY ALLOCATED?        JLM 
         BNE   RETURNGO                NO, CONTINUE                 JLM 
         L     R10,MEMADDR             ADDRESS OF MEMORY ALLOCATED  JLM 
         FREEMAIN R,LV=CLSMEML,A=(10)  FREE GETMAINED AREA          JLM 
*                                                                       
RETURNGO L     R13,4(R13)                                               
         RETURN (14,12),RC=0                                            
*                                                                       
***  D A T A   A R E A S   A N D   C O N S T A N T S                    
SMCASID  EQU   16                  SYSTEM ID                            
ENDTBL   EQU   X'FF'               END OF TABLE INDICATOR               
TBLUSED  EQU   X'FF'               ENTRY HAS BEEN USED INDICATOR        
ERRINDIC DC    X'00'               ERROR INDICATOR BYTE                 
LSPACERR EQU   X'80'               ERROR RETURNED FROM LSPACE FOR VOL   
SYSINFND DC    CL1'N'                  SYSIN ALLOCATED FLAG         JLM 
MEMALLOC DC    CL1'N'                  MEMORY 'GETMAIN' FLAG        JLM 
MEMADDR  DC    F'0'                    ACQUIRED MEMORY              JLM 
CLSHI    DC    H'0'                    HIGH TABLE ENTRY             JLM 
Y2KGD    DS    0CL30                   RETURN AREA FOR Y2KGETD      JLM 
Y2KGDG   DS    CL8                       CURRENT DATE GREGORIAN     JLM 
Y2KGDJ   DS    CL7                       CURRENT DATE JULIAN        JLM 
Y2KGDA   DS    CL7                       CURRENT DATE ASTRO         JLM 
Y2KGDT   DS    0CL8                      CURRENT TIME               JLM 
Y2KGDH   DS    CL2                         CURRENT HOUR             JLM 
Y2KGDM   DS    CL2                         CURRENT MINUTE           JLM 
Y2KGDS   DS    CL2                         CURRENT SECOND           JLM 
         DS    CL2                         CURRENT 100/1000THS      JLM 
Y2KDF    DS    0CL42                   RETURN AREA FOR Y2KDFMT      JLM 
Y2KDFG   DS    CL8                       GREGORIAN DATE (MMDDYYYY)  JLM 
Y2KDFC   DC    CL2'91'                   TEXT FORMAT, US            JLM 
Y2KDFR   DS    CL1                       RETURN CODE                JLM 
Y2KDFL   DS    CL2                       LENGTH OF RETURN AREA      JLM 
Y2KDFD   DS    CL29                      FORMATTED DATE             JLM 
*                                                                       
VOLTSTR  DC    CL4'STRG'                                                
VOLTPRV  DC    CL4'PRIV'                                                
VOLTPUB  DC    CL4'PUB '                                                
STATRMOV DC    CL5'REMOV'                                               
STATRESV DC    CL5'RESRV'                                               
STATPRES DC    CL5'RSDNT'                                               
*                                                                       
DECTIME  DC    F'0'                                                     
TOTENTP  DC    A(0)               POINTER TO LAST COMMENT ENTRY         
TOTENTN  DC    F'0'               TOTAL NUMBER OF COMMENT ENTRIES       
XFFFF    DC    X'FFFF'                                                  
TOTAL    DC    C'0TOTALS'                                               
SAVEAREA DS    18F                                                      
*                                                                       
LSPACPRM EQU   *                                                        
         DS    10F                                                      
         ORG   LSPACPRM+8                                               
PARMAREA EQU   *                   LSPACE INFO RETURN FIELD             
         ORG   PARMAREA+6          BEGINNNING OF CHAR FILEDS            
PRMFSTCC DS    CL4,CL1             FREE TOTAL CYL (CHAR)                
PRMFSTTC DS    CL4,CL1             FREE TOTAL TRK (CHAR)                
PRMFSEXC DS    CL4,CL1             FREE EXTENTS   (CHAR)                
PRMFSCCC DS    CL4,CL1             LARGEST CONTIG CYL (CHAR)            
PRMFSCTC DS    CL4                 LARGEST CONTIG TRK (CHAR)            
         ORG   PARMAREA+15         BEGINNING OF PACKED FIELDS           
FREESPAC EQU   *                                                        
PRMFSTCP DS    CL3                 FREE TOT CYL (PACKED)                
PRMFSTTP DS    CL3                 FREE TOT TRK (PACKED)                
PRMFSEXP DS    CL3                 FREE EXTENTS   (PACKED)              
PRMFSCCP DS    CL3                 LARGEST CONTIG CYL (PACKED)          
PRMFSCTP DS    CL3                 LARGEST CONTIG TRK (PACKED)          
         ORG                                                            
*                                                                       
VATRCRD  DS    0CL80               VATLST RECORD LAYOUT                 
VATRVOLS DS    CL6                 VOLSER                               
         DS    CL23                FILLER                               
VATRCMNT DS    CL35                COMMENT FIELD                        
         DS    CL16                FILLER                               
*                                                                       
         ORG   VATRCRD             REUSE MEMORY FOR SYSIN RECORD    JLM 
SYSINREC DS    0CL80               SYSIN RECORD LAYOUT              JLM 
SYSINVOL DS    CL6                 VOLSER MASK                      JLM 
         DS    CL64                FILLER                           JLM 
         ORG   ,                                                    JLM 
*                                                                       
MSGTBL   EQU   *                                                        
         DC    CL16'PERM I/O ERROR' RC=4                                
         DC    CL16'NON-STANDARD VOL' RC=8                              
         DC    CL16'UCB NOT READY' RC=12                                
         DC    CL16'LSPACE RC=16'  RC=16                                
*                                                                       
DEVTBL   EQU   *                                                        
DEV2311  DC    X'01',X'00',CL6' 2311 ',6PL4'0'          2020/04     JLM 
DEV23051 DC    X'06',X'00',CL6'2305-1',6PL4'0'                          
DEV23052 DC    X'07',X'00',CL6'2305-2',6PL4'0'                          
DEV2314  DC    X'08',X'00',CL6' 2314 ',6PL4'0'                          
DEV3330  DC    X'09',X'00',CL6' 3330 ',6PL4'0'                          
DEV3340  DC    X'0A',X'00',CL6' 3340 ',6PL4'0'                          
DEV3350  DC    X'0B',X'00',CL6' 3350 ',6PL4'0'                          
DEV3375  DC    X'0C',X'00',CL6' 3375 ',6PL4'0'          2020/04     JLM 
DEV33301 DC    X'0D',X'00',CL6'3330-1',6PL4'0'                          
DEV3380  DC    X'0E',X'00',CL6' 3380 ',6PL4'0'                          
DEV3390  DC    X'0F',X'00',CL6' 3390 ',6PL4'0'          2020/04     JLM 
DEVUNKWN DC    X'FF',X'00',CL6'UNKNWN',6PL4'0'                          
*                                                                       
FREETOTS EQU   *                   TOTAL FREE SPACE COUNTERS            
TOTCPRV  DC    PL4'0'              PRV CYL TOTAL                        
TOTTPRV  DC    PL4'0'              PRV TRK TOTAL                        
TOTCPUB  DC    PL4'0'              PUB CYL TOTAL                        
TOTTPUB  DC    PL4'0'              PUB TRK TOTAL                        
TOTCSTR  DC    PL4'0'              STR CYL TOTAL                        
TOTTSTR  DC    PL4'0'              STR TRK TOTAL                        
*                                                                       
PATTERN1 DC    X'402020202120222020202120224020202021202240404040404040X
               202020212022404040402020202120'                          
PATTERN2 DC    X'402020202020212022402020202020212022404040202020202021X
               20222020202020212022404040202020202021202240202020202021X
               20'                                                      
PATTERN3 DC    X'4020202020202120224020202020202120'                    
*                                                                       
HEADINGA DC    CL121' '                                                 
         ORG   HEADINGA                                                 
         DC    C'1IBHLSPAC  V2L5      D I R E C T    A C C E S S    S PX
                A C E      '                                            
HEADING1 DC    CL4' ',CL3' '                                            
HEADING2 DC    CL19' ',CL3' '                                           
HEADING3 DC    CL8'  :  :  '                                            
         ORG                                                            
HEADINGB DC    CL121'-VOLSER  FREE  FREE   FREE    LARGEST CONTIG FREE X
               AREA  UNIT    DEVICE    ---STATUS--    ----COMMENTS----' 
HEADINGC DC    CL121'         CYLS  TRKS  EXTENTS     CYLINDERS  TRACKSX
                              TYPE'                                     
HEADINGD DC    CL121'-DEVICE     ---PRIVATE---       ---PUBLIC---      X
                ---STORAGE---'                                          
HEADINGE DC    CL121'  TYPE      CYLS     TRKS       CYLS    TRKS      X
                CYLS     TRKS'                                          
HEADINGF DC    CL121'-VOLUME     FREE     FREE '                        
HEADINGG DC    CL121'  TYPE      CYLS     TRKS '                        
HEADINGH DC    CL121'0'                                                 
         ORG   HEADINGH+1                                               
         DC    91C'-'                                                   
         ORG                                                            
OUTLINE  DC    CL121' '                                                 
         ORG   OUTLINE+1                                                
OUTLINE1 DS    CL6' '              VOL SER                              
OUTLINE2 DS    CL(L'PATTERN1)' '   FREE SPACE VALUES                    
         ORG   OUTLINE2+4                                               
OUTLINE3 DS    CL16' '             ERROR MSG                            
         DS    CL29' '                                                  
OUTLINE4 DS    CL3' '              UNIT ADDRESS                         
         DS    CL5' '                                                   
OUTLINE5 DS    CL6' '              DEVICE TYPE                          
         DS    CL4' '                                                   
OUTLINE6 DS    CL4' '              VOL TYPE                             
         DS    CL2' '                                                   
OUTLINE7 DS    CL5' '              VOL STATUS                           
         DS    CL5' '                                                   
OUTLINE8 DS    CL35' '             VOL COMMENTS                         
         ORG   OUTLINE+1                                                
OUTLINEA DS    CL6' '              DEVICE TYPE                          
         DS    CL1' '                                                   
OUTLINEB DS    CL(L'PATTERN2)' '   FREE SPACE TOTALS                    
         ORG                                                            
*                                                                       
         PRINT NOGEN                                                    
SYSPRINT DCB   DDNAME=SYSPRINT,MACRF=PM,LRECL=121,DSORG=PS,            X
               BLKSIZE=4840,RECFM=FBA                                   
VATLST   DCB   DDNAME=VATLST,MACRF=GM,LRECL=80,DSORG=PS,               X
               EODAD=EOFCMNTS                                           
SYSIN    DCB   DDNAME=SYSIN,MACRF=GM,LRECL=80,DSORG=PS,             JLMX
               EODAD=EOFSYSIN                                       JLM 
*                                                                       
         LTORG                                                          
*                                                                       
CMNTABLE DS    CL(200*41)              VATLST VOLSER COMMENT TABLE      
*                                                                       
CLSMEM   DSECT                         MEMORY FOR CATEGORY TABLE    JLM 
CLSTAB   DS    0H                      CLASS TABLE                  JLM 
CLSMSK   DS    CL6                     VOLSER MASK                  JLM 
CLSMSKL  DS    H                       MASK SIGNIFICANT LENGTH      JLM 
CLSCYL   DS    PL4                     CYLINDER TOTAL               JLM 
CLSTRK   DS    PL4                     TRACKS TOTAL                 JLM 
CLSENTL  EQU   (*-CLSTAB)              LENGTH OF ENTRY              JLM 
         DS    CL(CLSENTL*20)          STORAGE FOR 20 MORE ENTRIES  JLM 
CLSTABL  EQU   (*-CLSTAB)              LENGTH OF TABLE              JLM 
CLSMEML  EQU   (*-CLSMEM)              LENGTH OF MEMORY REQUIRED    JLM 
*                                                                       
         PRINT ON,NOGEN                                                 
         CVT   DSECT=YES                                            JLM 
TIOTDS   DSECT ,                                                    JLM 
         IEFTIOT1 ,                                                 JLM 
         IKJTCB   ,                                                 JLM 
         PRINT ON,GEN                                                   
         EJECT                                                          
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*  OPTCHAN - OPTIONAL CHANNEL ROUTINE                                 * 
*                                                                     * 
*  THIS ROUTINE IS TO DETERMINE IF A UCB HAS ALREADY BEEN PROCESSED   * 
*  BY THE PROGRAM.  OPTCHAN WILL MAINTAIN A TABLE OF SERIAL NUMBERS   * 
*  AND BASED ON THIS INFORMATION DECIDE IF UCB HAS ALREADY BEEN       * 
*  PROCESSED.                                                         * 
*                                                                     * 
*  ENTRY - REGISTER 0 CONTAINS ADDRESS OF UCB UNDER CONSIDERATION.    * 
*                                                                     * 
*  EXIT  - REGISTER 15 IS RETURN CODE:                                * 
*          0 - UCB HAS NOT BEEN PROCESSED.                            * 
*          4 - UCB HAS BEEN PROCESSED.                                * 
*                                                                     * 
*  ABNORMAL CONDITIONS:                                               * 
*  U100 - NUMBER OF UNIQUE UCBS HAS EXCEEDED 100.                     * 
*  U200 - REGISTER 0 WAS INVALID.                                     * 
*                           ADDED R. PIEPENBRINK / WALGREENS 04/77    * 
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*                                                                       
OPTCHK   CSECT                                                          
         SAVE (14,12),,*                                                
         LR    R12,R15        BASE FOR ROUTINE                          
         USING OPTCHK,R12                                               
         ST    R13,OPTSAVE+4                                            
         LA    R11,OPTSAVE                                              
         ST    R11,8(R13)                                               
         LR    R13,R11             LINKAGE COMPLETE                     
*                                                                       
* IS VOLSER IN TABLE?                                                   
         LR    R9,R0               R9 IS BASE FOR UCB                   
         USING UCBDSECT,R9                                              
         CLI   UCBID,X'FF'         IS IT A UCB?                         
         BNE   OPTU200             NO - ABEND U200.                     
         LA    R4,OPTABLE          ADDRESS TABLE                        
         USING OPDSECT,R4                                               
         LA    R6,OPEND-OPDSECT    SET INDEXING VALUE FOR BXH           
         LA    R7,OPTLAST          LAST ENTRY IN TABLE                  
*                                                                       
OPLOOP1  EQU   *                                                        
         CLI   OPDSECT,X'FF'       END OF ENTRIES USED?                 
         BE    OPNOTIN             YES - VOLSER NOT USED.               
         CLC   OPVOLI,UCBVOLI      HAS IT BENN PROCESSED?               
         BE    OPVOLIN             YES - VOLER WAS PROCESSED.           
         BXLE  R4,R6,OPLOOP1       FINISH TABLE.                        
         B     OPTU100                                                  
*                                                                       
* VOLSER WAS PROCESSED.                                                 
OPVOLIN  DS    0H                                                       
         LA    R15,4               SET RETURN CODE. UCB PROCESSED       
         B     OPOUT               GO TO EXIT.                          
*                                                                       
* VOLSER WAS NOT IN TABLE.                                              
OPNOTIN  DS    0H                                                       
         CR    R4,R7               IS TABLE FULL?                       
         BL    OPSKIP1             NO - BRANCH AROUND ABEND.            
*                                                                       
* THE TABLE IS FULL                                                     
OPTU100  EQU   *                                                        
         ABEND 100,DUMP            TABLE FULL. ABEND U100.              
*                                                                       
*  REGISTER 0 DOES NOT REFERENCE A VALID UCB.                           
OPTU200  DS    0H                                                       
         ABEND 200,DUMP                                                 
*                                                                       
OPSKIP1  DS    0H                                                       
         MVC   OPVOLI,UCBVOLI      MOVE IN VOLSER                       
         MVI   OPEND,X'FF'         INDICATE LAST ENTRY USED             
*                                                                       
* VOLSER WAS NOT PROCESSED                                              
         SR    R15,R15             SET RETURN CODE. UCB NOT PROCESSED.  
*                                                                       
* EXIT FROM OPTCHK                                                      
OPOUT    EQU   *                                                        
         L R13,4(R13)              RESTORE R13                          
         RETURN (14,12),RC=(15)                                         
         BR    R14                 EXIT.                                
*                                                                       
         LTORG                                                          
*                                                                       
* THIS IS THE TABLE OF VOLUME SERIAL NUMBERS. THE LAST ENTRY IS         
* INDICATED BY THE FIRST BYTE BEING X'FF'  EACH ENTRY IS 6 BYTES.       
OPTABLE  DC    X'FF',CL5' '        FIRST ENTRY INDICATED AS LAST.       
         DC    98CL6' '            OTHER ENTRIES.                       
OPTLAST  DC    CL6' '              LAST ENTRY                           
OPTSAVE  DS    18F                 REGISTER SAVEAREA                    
         EJECT                                                          
UCBDSECT DSECT                                                          
         DS    2X                                                       
UCBID    DS    X                   UCB ID. SHOULD BE X'FF'              
UCBSTAT  DS    XL1                 DEVICE STATUS                        
UCBONLI  EQU   X'80'               DEVICE IS ONLINE                     
UCBRESV  EQU   X'20'               VOL IS RESERVED                      
UCBPRES  EQU   X'04'               VOL IS PERM RESIDENT                 
         DS    9X                                                       
UCBNAME  DS    CL3                 UNIT NAME                            
UCBTYP   DS    XL4                 DEVICE TYPE                          
TYPDA    EQU   X'20'               DIRECT ACCESS                        
TYP2321  EQU   X'05'               2321 DATA CELL                       
         DS    8X                                                       
UCBVOLI  DS    CL6                 DEVICE VOLSER                        
UCBSTAB  DS    XL1                 VOLUME STATUS                        
UCBBPRV  EQU   X'10'               PRIVATE VOLUME                       
UCBBPUB  EQU   X'08'               PUBLIC VOLUME                        
UCBBSTR  EQU   X'04'               STORAGE VOLUME                       
*                                                                       
CMNTENTY DSECT                                                          
CMNTVOLS DS    CL6                 VOLSER                               
CMNTCMNT DS    CL35                COMMENT FIELD                        
CMNTENTL EQU   *-CMNTENTY                                               
*                                                                       
TBLDSECT DSECT                                                          
TBLDEV   DS    XL1                 DEVICE TYPE ENTRY                    
TBLUSE   DS    XL1                 USE INDICATOR                        
TBLNAME  DS    CL6                 DEVICE NAME                          
DEVTOTS  EQU   *                                                        
TBLCPRV  DS    PL4                 PRV CYL COUNTER                      
TBLTPRV  DS    PL4                 PRV TRK COUNTER                      
TBLCPUB  DS    PL4                 PUB CYL COUNTER                      
TBLTPUB  DS    PL4                 PUB TRK COUNTER                      
TBLCSTR  DS    PL4                 STR CYL COUNTER                      
TBLTSTR  DS    PL4                 STR TRK COUNTER                      
NXTDEV   EQU   *                                                        
*                                                                       
OPDSECT  DSECT                                                          
OPVOLI   DS    CL6                 VOLUME SERIAL ENTRY                  
OPEND    DS    0C                                                       
*                                                                       
         END   IBHLSPAC                                                 
//LKED.SYSLMOD DD DSN=SYSC.LINKLIB,DISP=SHR   <-- TARGET LOAD LIBRARY   
//LKED.SYSLIB DD DISP=SHR,DSN=SYSC.LINKLIB        (FOR DATE ROUTINES)   
//LKED.SYSIN DD *                                                       
  NAME IBHLSPAC(R)                                                      
//                                                                      
